/* Parham Data Products                                                      */
/* Expert Rules Engine                                                       */
/* expert/model/rulesDetails/promo/PromoInferenceEngine                      */
/* Copyright 2020 Wayne Parham                                               */

package com.parhamdata.expert.model.rulesDetails.promo;

import com.parhamdata.expert.model.rulesEngine.InferenceEngine;
import com.parhamdata.expert.model.RulesetDomain;
import com.parhamdata.expert.services.databaseService.RuleRecord;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Service;

@Service
public class PromoInferenceEngine extends InferenceEngine<ShoppingCart, PromoItem> {

    @Override
    protected RulesetDomain getDomain() {
        return RulesetDomain.PROMO;
    }

    @Override
    protected PromoItem initializeOutputResult() {
        return PromoItem.builder().build();
    }
}