/* Parham Data Products                                                      */
/* Expert Rules Engine                                                       */
/* expert/model/rulesDetails/promoAggregate/PromoAggregateInput              */
/* Copyright 2020 Wayne Parham                                               */

package com.parhamdata.expert.model.rulesDetails.promoAggregate;

import java.util.ArrayList;
import lombok.AllArgsConstructor;
import lombok.NoArgsConstructor;
import lombok.Builder;
import lombok.Data;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class PromoAggregateInput {
    @Data
    public static class Promo {
        Boolean    status;
        String     notes;
        Float      cartTotal;
        String     promoUpc;
        String     promoDescription;
        String     promoCategory;
        Float      promoPrice;
        Integer    promoQty;
    }

    public ArrayList<Promo> promos;

    public Integer best() {
        int i = 0;
        Integer index = null;
        Float price = (float) 0;
        for (Promo promo : promos) {
            if (promo.getPromoPrice() > price) {
                price = promo.getPromoPrice();
                index = i;
            }
            i++;
        }
        return index;
    }

    public Integer bestInCategory(String category) {
        int i = 0;
        Integer index = null;
        Float price = (float) 0;
        for (Promo promo : promos) {
            if (promo.getPromoCategory().equalsIgnoreCase(category) &&
                    promo.getPromoPrice() > price) {
                price = promo.getPromoPrice();
                index = i;
            }
            i++;
        }
        return index;
    }

    public Float cartTotal() {
        if (promos.size() > 0) {
            return promos.get(0).getCartTotal();
        } else {
            return null;
        }
    }

    public Boolean getStatus(Integer index) { return promos.get(index).getStatus(); }
    public String  getNotes(Integer index) { return promos.get(index).getNotes(); }
    public Float   getCartTotal(Integer index) { return promos.get(index).getCartTotal(); }
    public String  getPromoUpc(Integer index) { return promos.get(index).getPromoUpc(); }
    public String  getPromoDescription(Integer index) { return promos.get(index).getPromoDescription(); }
    public String  getPromoCategory(Integer index) { return promos.get(index).getPromoCategory(); }
    public Float   getPromoPrice(Integer index) { return promos.get(index).getPromoPrice(); }
    public Integer getPromoQty(Integer index) { return promos.get(index).getPromoQty(); }
}