/* Parham Data Products                                                      */
/* Expert Rules Engine                                                       */
/* main/expert/model/rulesEngine/RulesEngine                                 */
/* Copyright 2020 Wayne Parham                                               */

package com.parhamdata.expert.model.rulesEngine;

import com.parhamdata.expert.services.rulesetFunctions.RulesetFunctions;
import com.parhamdata.expert.services.databaseService.Rule;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.util.List;

@Service
public class RulesEngine {

    @Autowired
    private RulesetFunctions runner;

    public Object run(InferenceEngine inferenceEngine, Object inputData, Boolean multipleResultsAllowed) {
        String domain = inferenceEngine.getDomain().toString();
        if (domain.equalsIgnoreCase("EXPERT"))  { domain = ""; }
        List<Rule> Rules = runner.getAllRulesInDomain(domain);
        Object result = inferenceEngine.run(Rules, inputData, multipleResultsAllowed);
        return result;
    }
}