/* Parham Data Products                                                      */
/* Expert Rules Engine                                                       */
/* main/expert/model/rulesEngine/variableResolver/KeywordResolver            */
/* Copyright 2020 Wayne Parham                                               */

package com.parhamdata.expert.model.rulesEngine.variableResolver;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import lombok.NoArgsConstructor;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.function.Function;
import java.util.stream.Collectors;

@Service
@NoArgsConstructor
public class KeywordResolver {
    Map<String, VariableResolver> variableResolverList;

    @Autowired
    public KeywordResolver(List<VariableResolver> resolverList) {
        variableResolverList = resolverList.stream()
                .collect(Collectors.toMap(VariableResolver::getResolverKeyword, Function.identity()));
    }

    public Map<String, VariableResolver> getVariableResolverList(){
        return variableResolverList;
    }

    public Optional<VariableResolver> getResolver(String keyword) {
        return Optional.ofNullable(variableResolverList.get(keyword));
    }
}
