/* Parham Data Products                                                      */
/* Expert Rules Engine                                                       */
/* main/expert/services/databaseService                                      */
/* Copyright 2020 Wayne Parham                                               */

package com.parhamdata.expert.services.databaseService;

import org.springframework.beans.factory.annotation.Value;
import lombok.AllArgsConstructor;
import lombok.NoArgsConstructor;
import lombok.Builder;
import lombok.Data;
import jakarta.persistence.IdClass;
import jakarta.persistence.Column;
import jakarta.persistence.Table;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;

@Data
@Entity
@Builder
@NoArgsConstructor
@AllArgsConstructor
@IdClass(RuleId.class)
@Table(name = "rules")
public class RuleRecord {

    @Id
    @Value("EXPERT")
    @Column(name = "domain")
    private String domain;

    @Id
    @Column(name = "id")
    private Integer id;

    @Column(name = "conditions", length = 65535, columnDefinition = "text")
    private String condition;

    @Column(name = "actions", length = 65535, columnDefinition = "text")
    private String action;

    @Column(name = "priority")
    private Integer priority;

    @Column(name = "description")
    private String description;

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder("{");
        sb.append("\"domain\"=").append(domain).append(", ");
        sb.append("\"id\"=").append(id).append(", ");
        sb.append("\"condition\"=\"").append(condition).append("\", ");
        sb.append("\"action\"=\"").append(action).append("\"");
        sb.append("\"priority\"=\"").append(priority).append("\"");
        sb.append("\"description\"=\"").append(description).append("\"");
        sb.append('}');
        return sb.toString();
    }
}